| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | List of all members
Tp::Service::ConnectionInterfaceLocationAdaptor Class Reference
Service-side implementation » Connection service implementation

`#include <TelepathyQt/_gen/svc-connection.h>`

Inheritance diagram for Tp::Service::ConnectionInterfaceLocationAdaptor:
[legend]

## Public Slots

Tp::ContactLocations | GetLocations (const Tp::UIntList &contacts, const QDBusMessage &dbusMessage)
QVariantMap | RequestLocation (uint contact, const QDBusMessage &dbusMessage)
void | SetLocation (const QVariantMap &location, const QDBusMessage &dbusMessage)

## Signals

void | LocationUpdated (uint contact, const QVariantMap &location)

## Public Member Functions

Tp::UIntList | LocationAccessControlTypes () const
Tp::RichPresenceAccessControl | LocationAccessControl () const
void | SetLocationAccessControl (const Tp::RichPresenceAccessControl &newValue)
uint | SupportedLocationFeatures () const
Public Member Functions inherited from Tp::AbstractAdaptor
| AbstractAdaptor (const QDBusConnection &connection, QObject *adaptee, QObject *parent)
| ~AbstractAdaptor ()
QDBusConnection | dbusConnection () const
QObject * | adaptee () const
Public Member Functions inherited from QDBusAbstractAdaptor
| ~QDBusAbstractAdaptor ()
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Additional Inherited Members

Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)
Protected Member Functions inherited from QDBusAbstractAdaptor
| QDBusAbstractAdaptor (QObject *obj)
void | setAutoRelaySignals (bool enable)
bool | autoRelaySignals () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Adaptor class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.Location".

## Member Function Documentation

Tp::UIntList Tp::Service::ConnectionInterfaceLocationAdaptor::LocationAccessControlTypes | ( |  | ) | const

Return the value of the exported D-Bus object property `LocationAccessControlTypes` of type `Tp::UIntList`.

Adaptees should export this property as a Qt property named 'locationAccessControlTypes' with type Tp::UIntList.

The types of access control that are supported by this connection.

Returns
  The value of exported property `LocationAccessControlTypes`.

Tp::RichPresenceAccessControl Tp::Service::ConnectionInterfaceLocationAdaptor::LocationAccessControl | ( |  | ) | const

Return the value of the exported D-Bus object property `LocationAccessControl` of type `Tp::RichPresenceAccessControl`.

Adaptees should export this property as a Qt property named 'locationAccessControl' with type Tp::RichPresenceAccessControl.

The current access control mechanism and settings for this connection. Before publishing location for the first time, if this has not been set by a client, implementations SHOULD set it to be as restrictive as possible (an empty whitelist, if supported).

Returns
  The value of exported property `LocationAccessControl`.

void Tp::Service::ConnectionInterfaceLocationAdaptor::SetLocationAccessControl | ( | const Tp::RichPresenceAccessControl & | newValue | ) |

Set the value of the exported D-Bus object property `LocationAccessControl` of type `Tp::RichPresenceAccessControl`.

Adaptees should export this property as a writable Qt property named 'locationAccessControl' with type Tp::RichPresenceAccessControl.

The current access control mechanism and settings for this connection. Before publishing location for the first time, if this has not been set by a client, implementations SHOULD set it to be as restrictive as possible (an empty whitelist, if supported).

uint Tp::Service::ConnectionInterfaceLocationAdaptor::SupportedLocationFeatures | ( |  | ) | const

Return the value of the exported D-Bus object property `SupportedLocationFeatures` of type `uint`.

Adaptees should export this property as a Qt property named 'supportedLocationFeatures' with type uint.

Indicates the Location features supported by this connection. This property MAY be undefined before ConnectionInterface::Status becomes `Connected`, but MUST remain constant thereafter.

Returns
  The value of exported property `SupportedLocationFeatures`.

Tp::ContactLocations Tp::Service::ConnectionInterfaceLocationAdaptor::GetLocations | ( | const Tp::UIntList & | contacts,
|  | const QDBusMessage & | dbusMessage
| ) |  |

slot

Begins a call to the exported D-Bus method `GetLocations` on this object.

Adaptees should export this method as a Qt slot with the following signature: void getLocations(const Tp::UIntList& contacts, const Tp::Service::ConnectionInterfaceLocationAdaptor::GetLocationsContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Return the current locations of the given contacts, if they are already known. If any of the given contacts' locations are not known, request their current locations, but return immediately without waiting for a reply; if a reply with a non-empty location is later received for those contacts, the LocationUpdated() signal will be emitted for them.

This method is appropriate for "lazy" location finding, for instance displaying the location (if available) of everyone in your contact list.

For backwards compatibility, if this method is called by a client whose "interest count" for this interface, as defined by ConnectionInterface::AddClientInterest() , is zero, the Connection SHOULD behave as if AddClientInterest had been called for this interface just before that method call. Clients that do not explicitly call AddClientInterest SHOULD NOT call ConnectionInterface::RemoveClientInterest() either.

Parameters

  contacts

      The contacts whose locations should be returned or signalled.

Returns

      The contacts&apos; locations, if already known. Contacts whose
      locations are not already known are omitted from the mapping;
      contacts known to have no location information appear in the
      mapping with an empty Location dictionary.

QVariantMap Tp::Service::ConnectionInterfaceLocationAdaptor::RequestLocation | ( | uint | contact,
|  | const QDBusMessage & | dbusMessage
| ) |  |

slot

Begins a call to the exported D-Bus method `RequestLocation` on this object.

Adaptees should export this method as a Qt slot with the following signature: void requestLocation(uint contact, const Tp::Service::ConnectionInterfaceLocationAdaptor::RequestLocationContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Return the current location of the given contact. If necessary, make a request to the server for up-to-date information, and wait for a reply. This method is appropriate for use in a "Contact Information..." dialog; it can be used to show progress information (while waiting for the method to return), and can distinguish between various error conditions.

Parameters

  contact

      The contact whose location should be returned.

Returns

      The contact&apos;s location. It MAY be empty, indicating that no
      location information was found.

void Tp::Service::ConnectionInterfaceLocationAdaptor::SetLocation | ( | const QVariantMap & | location,
|  | const QDBusMessage & | dbusMessage
| ) |  |

slot

Begins a call to the exported D-Bus method `SetLocation` on this object.

Adaptees should export this method as a Qt slot with the following signature: void setLocation(const QVariantMap& location, const Tp::Service::ConnectionInterfaceLocationAdaptor::SetLocationContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Set the local user's own location.

Parameters

  location

      The location to advertise. If the user wants to obscure their exact
      location by reducing the precision or accuracy, clients MUST do
      this themselves, rather than relying on the connection manager to
      do so. Clients that interact with more than one connection SHOULD
      advertise the same reduced-accuracy location to all of them, so
      that contacts cannot obtain an undesirably accurate location by
      assuming that random errors have been added and averaging the
      locations advertised on multiple connections.

void Tp::Service::ConnectionInterfaceLocationAdaptor::LocationUpdated | ( | uint | contact,
|  | const QVariantMap & | location
| ) |  |

signal

Represents the exported D-Bus signal `LocationUpdated` on this object.

Adaptees should export this signal as a Qt signal with the following signature: void locationUpdated(uint contact, const QVariantMap& location);

The adaptee signal will be automatically relayed as a D-Bus signal once emitted.

Parameters

  contact

      The contact

  location

      The contact&apos;s location, or empty to indicate that nothing is
      known about the contact&apos;s location.